#!/usr/bin/Rscript

# Paul Johnson <pauljohn@ku.edu> 2015-08-25


options(repos="http://rweb.crmda.ku.edu/cran")

#update everything, important to checkBuilt
update.packages(ask = FALSE, checkBuilt = TRUE)

## List other things we may not have yet

A <- c("Rcmdr", "car", "rgl", "gdata", "gmodels", "TeachingDemos",
       "plotrix", "ggplot2", "plotmo")

## Structural Equations
B <- c("sem", "lavaan", "lavaan.survey", "lava", "MplusAutomation")

## General purpose, widely used

C <- c("car", "memisc","rms","Hmisc", "survey", "psych", "openxlsx")

## Regression

D <- c("betareg", "segmented", "lme4", "MEMSS", "languageR", "gamm4",
       "glmmBUGS", "influence.ME", "ineq", "lmec","lmm",
       "lmerTest", "longitudinal", "plm", 
       "longitudinalData", "MCMCglmm","MCPAN", "MEMSS", "flexmix",
       "quantreg", "glmmML", "eha", "systemfit", "VGAM", "rockchalk",
       "sandwich", "scatterplot3d", "mediation", "glmnet", "gam",
       "acepack")

## Flexible Curves

E <- c("tree","mda","earth", "lars", "locfit", "pspline", "np", "dse",
       "akima", "aod", "gee", "geepack", "cslogistic")

## Missing Data

F <- c("norm", "Amelia", "mix", "pan", "mice", "mitools", "VIM", "mi")

## Variable selection

G <- c("stepwise","subselect", "leaps", "caret", "bestglm", "relimp",
       "party", "multcomp", "strucchange", "SoDA", "sna" )

## Specialized Regression

H <- c("Zelig","pscl","wnominate", "dlm")

## Etc

I <- c("rlecuyer", "biglm", "roxygen2", "plyr", "reshape2", "zoo",
       "texreg", "tables", "maps", "maptools", "markdown", "microbenchmark",
       "RCurl", "Matching", "MatchIt", "knitr", "formatR", "coda",
       "data.table", "copula")

desiredPackages <- unique(c(A, B, C, D, E, F, G, H, I))

## list of all currently installed packages

installedPackages <- rownames (installed.packages() )

# TRUE/FALE indicator for each desiredPackage
alreadyHave <- desiredPackages %in% installedPackages

#install ones that are in the New list
if (sum(!alreadyHave) > 0) install.packages(desiredPackages[!alreadyHave],
                                            dependencies=c("Imports","LinkingTo","Depends"))

